package yartiss.engine.simulation;


public interface IStatisticCriterion {
	
	public void simulationStarted();
	public void simulationEnd(long date);
	public void nextEventReady(Event event);
	public void eventPerformed(Event event);
	public SimulationParameters getSimulationParameters();
	public void setSimulationParameters(SimulationParameters p);
	
	public String getName();
	public IStatisticCriterion newInstance();
	public Class<?> getValueType();
	public Object getValue();
	public Object getAggregatedValue();
	public void aggregate(Object value, SimulationStatistics result);

}
