package yartiss.engine.simulation;

import java.util.HashMap;
import java.util.Map;

import yartiss.engine.simulation.statistics.StatisticsManager;


public class SimulationStatistics {
	
	private Event lastEvent;
	
	private Map<String, IStatisticCriterion> statistics = new HashMap<String, IStatisticCriterion>();
	
	public void addProperty(String property, IStatisticCriterion value){
		statistics.put(property, value);
	}
	
	public Object getValue(String property){
		if(statistics.containsKey(property))
			return statistics.get(property).getValue();
		return null;
	}
	
	public IStatisticCriterion getCriterion(String property){
		if(statistics.containsKey(property))
			return statistics.get(property);
		return null;
	}
	
	public void aggregate(String property, SimulationStatistics result){
		if(!statistics.containsKey(property))
			addProperty(property, StatisticsManager.getInstance(property));
		statistics.get(property).aggregate(result.getValue(property), result);
	}
	
	public Object getAggregatedValue(String property){
		if(statistics.containsKey(property))
			return statistics.get(property).getAggregatedValue();
		return null;
	}
	
	/**
	 * @return the lastEvent
	 */
	public Event getLastEvent() {
		return lastEvent;
	}
	/**
	 * @param lastEvent the lastEvent to set
	 */
	public void setLastEvent(Event lastEvent) {
		this.lastEvent = lastEvent;
	}
	
	public boolean isSuccess(){
		Object val = getValue("Success state");
		return val != null ? (Boolean)val : false;
	}
	
	public boolean isFailed(){
		return !isSuccess();
	}
	
	
	
	
	
	
	
	
}
