package yartiss.engine.simulation.comparison;

import java.util.ArrayList;
import java.util.List;

import yartiss.engine.simulation.ISchedulingPolicy;

public class ComparisonConfiguration {
	
	private String systemsSource = "";
	private boolean isDebug ;
	private List<ISchedulingPolicy> schedulingPolicies = new ArrayList<ISchedulingPolicy>();
	private List<ComparisonScenario> comparisonScenarios = new ArrayList<ComparisonScenario>();
	private long simulationDuration;
	private List<String> metrics = new ArrayList<String>();

	
	public ComparisonConfiguration(String systemsSource, boolean isDebug,
			List<ISchedulingPolicy> schedulingPolicies,
			List<ComparisonScenario> comparisonScenarios,
			long simulationDuration, List<String> metrics) {
		super();
		this.systemsSource = systemsSource;
		this.isDebug = isDebug;
		this.schedulingPolicies = schedulingPolicies;
		this.comparisonScenarios = comparisonScenarios;
		this.simulationDuration = simulationDuration;
		this.metrics = metrics;
	}
	
	
	/**
	 * @return the systemsSource
	 */
	public String getSystemsSource() {
		return systemsSource;
	}
	/**
	 * @param systemsSource the systemsSource to set
	 */
	public void setSystemsSource(String systemsSource) {
		this.systemsSource = systemsSource;
	}
	/**
	 * @return the isDebug
	 */
	public boolean isDebug() {
		return isDebug;
	}
	/**
	 * @param isDebug the isDebug to set
	 */
	public void setDebug(boolean isDebug) {
		this.isDebug = isDebug;
	}
	/**
	 * @return the schedulingPolicies
	 */
	public List<ISchedulingPolicy> getSchedulingPolicies() {
		return schedulingPolicies;
	}
	/**
	 * @param schedulingPolicies the schedulingPolicies to set
	 */
	public void setSchedulingPolicies(List<ISchedulingPolicy> schedulingPolicies) {
		this.schedulingPolicies = schedulingPolicies;
	}
	/**
	 * @return the comparisonScenarios
	 */
	public List<ComparisonScenario> getComparisonScenarios() {
		return comparisonScenarios;
	}
	/**
	 * @param comparisonScenarios the comparisonScenarios to set
	 */
	public void setComparisonScenarios(List<ComparisonScenario> comparisonScenarios) {
		this.comparisonScenarios = comparisonScenarios;
	}
	/**
	 * @return the simulationDuration
	 */
	public long getSimulationDuration() {
		return simulationDuration;
	}
	/**
	 * @param simulationDuration the simulationDuration to set
	 */
	public void setSimulationDuration(long simulationDuration) {
		this.simulationDuration = simulationDuration;
	}
	/**
	 * @return the metrics
	 */
	public List<String> getMetrics() {
		return metrics;
	}
	/**
	 * @param metrics the metrics to set
	 */
	public void setMetrics(List<String> metrics) {
		this.metrics = metrics;
	}
	
	
	
	

}
