package yartiss.engine.simulation.energy.profiles.consumption;

import java.util.Collections;
import java.util.List;

import yartiss.engine.simulation.IEnergyConsumptionProfile;

public class InstantaneousConsAtBeginning implements IEnergyConsumptionProfile {

	@Override
	public long getConsumed(long wcet, long wcee, long romainingTimeCost,	long duration) {
		if(romainingTimeCost == wcet)
			return wcee;
		return 0;
	}

	@Override
	public String getName() {
		return "Instantaneous at beginning";
	}

	@Override
	public List<Double> getParameters() {
		return Collections.emptyList();
	}

	@Override
	public void setParameters(List<Double> params) {

	}

	@Override
	public IEnergyConsumptionProfile cloneProfile() {
		return new InstantaneousConsAtBeginning();
	}

}
