package yartiss.engine.simulation.events;

import java.util.Map;

import yartiss.engine.simulation.Event;
import yartiss.engine.simulation.system.ITask;

public class CheckDeadlineEvent extends Event {

	protected CheckDeadlineEvent(ITask task,int procId, long date, Map<String, Long> metrics, EventGenerator eventGenerator) {
		super(task, procId, date, metrics, eventGenerator);
	}
	
	@Override
	public void actionPerformed(long date){
		boolean deadlinedMissed = getTask().checkDeadlineMissed(date);
		if(deadlinedMissed)
			getEventGenerator().generateEvent("deadline_missed",0, getTask(), date, null);
	}
	
	@Override
	public String getName(){
		return "check_deadline";
	}

	
	@Override
	public void accept(IEventVisitor visitor){
		visitor.visit(this);
	}
	
}
