package yartiss.engine.simulation.io;

import java.io.File;
import java.util.Arrays;

import yartiss.engine.simulation.io.many.ITasksetsReader;
import yartiss.engine.simulation.io.many.ITasksetsWriter;
import yartiss.engine.simulation.io.many.TasksetsIOFactory;
import yartiss.engine.simulation.system.ITask;
import yartiss.engine.simulation.system.SystemMetrics;

public class XmlTextTaksetsConverter {
	
	public static void TextToXml(String text, String xml) throws Exception{
		ITasksetsReader txtReader = TasksetsIOFactory.newTasksetsReaderInstance("txt",text);
		ITasksetsWriter xmlWriter = TasksetsIOFactory.newTasksetsWriterInstance("xml", xml);
		
		ITask[] set = null;
		
		while( (set=txtReader.nextTaskset())!=null){
			xmlWriter.write(set);
		}
		
		txtReader.close();
		xmlWriter.close();
	}

	public static void XmlToText(String xml, String text) throws Exception{
		ITasksetsReader xmlReader = TasksetsIOFactory.newTasksetsReaderInstance("xml",xml);
		ITasksetsWriter txtWriter = TasksetsIOFactory.newTasksetsWriterInstance("txt", text);
		
		ITask[] set = null;
		
		while( (set=xmlReader.nextTaskset())!=null){
			txtWriter.write(set);
		}
		
		xmlReader.close();
		txtWriter.close();
	}

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	public static void main(String[] args) throws Exception {
		System.out.println(new File("./").getAbsolutePath());
		String file = "file";
		XmlToText(file+".xml", file+".txt");

		ITasksetsReader textReader = TasksetsIOFactory.newTasksetsReaderInstance("txt", file+".txt");
		ITask[] readTaskSet = null;
		long hp = 0;
		long maxHP = 0;
		while((readTaskSet = textReader.nextTaskset()) != null){
			hp = SystemMetrics.hyperPeriod(Arrays.asList(readTaskSet));
			if(hp>maxHP)
				maxHP = hp;
			if(hp > 500){
				for (ITask iTask : readTaskSet) {
					System.out.println(iTask.getPeriod());
				}
				System.out.println("________________________________________"+SystemMetrics.hyperPeriod(Arrays.asList(readTaskSet)));
			}
		}
		System.out.println("max="+maxHP);
	}

	
}
