package yartiss.engine.simulation.io.many;

import java.io.File;
import java.io.InputStream;
import java.io.OutputStream;

public class TasksetsIOFactory {
	
	
		public static ITasksetsReader newTasksetsReaderInstance(String type,String src, long ... params) throws Exception{
			if(type.toLowerCase().equals("xml"))
				return new XmlTasksetsReader(src);
			return new TextTasksetsReader(src);
		}
		
		public static ITasksetsReader newTasksetsReaderInstance(String type,InputStream src, long ... params) throws Exception{
			if(type.toLowerCase().equals("xml"))
				return new XmlTasksetsReader(src);
			return new TextTasksetsReader(src);
		}
	
		public static ITasksetsReader newTasksetsReaderInstance(String type,File src, long ... params) throws Exception{
			if(type.toLowerCase().equals("xml"))
				return new XmlTasksetsReader(src);
			return new TextTasksetsReader(src);
		}
		
		public static ITasksetsWriter newTasksetsWriterInstance(String type,File dest, long ... params) throws Exception{
			if(type.toLowerCase().equals("xml"))
				return new XmlTasksetsWriter(dest, params.length>0  ? params[0] : 1);
			return new TextTasksetsWriter(dest, params.length>0  ? params[0] : 1);
		}
		
		public static ITasksetsWriter newTasksetsWriterInstance(String type,OutputStream dest, long ... params) throws Exception{
			if(type.toLowerCase().equals("xml"))
				return new XmlTasksetsWriter(dest,params.length>0  ? params[0] : 1);
			return new TextTasksetsWriter(dest, params.length>0  ? params[0] : 1);
		}
		
		public static ITasksetsWriter newTasksetsWriterInstance(String type,String dest, long ... params) throws Exception{
			if(type.toLowerCase().equals("xml"))
				return new XmlTasksetsWriter(dest, params.length>0  ? params[0] : 1);
			return new TextTasksetsWriter(dest, params.length>0  ? params[0] : 1);
		}
}
