package yartiss.engine.simulation.scheduling.policies.dp;

import java.util.SortedSet;

import yartiss.engine.simulation.IEnergyProfile;
import yartiss.engine.simulation.ISchedulingPolicy;
import yartiss.engine.simulation.events.EventGenerator;
import yartiss.engine.simulation.scheduling.policies.AbstractMonoProcessorSchedulingPolicy;
import yartiss.engine.simulation.system.ITask;
import yartiss.engine.simulation.system.ITaskSet;

public class EDF extends AbstractMonoProcessorSchedulingPolicy {

	
	public EDF(String tasksetType, String policyName) {
		super(tasksetType, policyName);
		policyName = "EDF";
		tasksetType = "deadline";
	}
	
	public EDF(){
		this("deadline","EDF");
	}
	

	@Override
	public ITask chooseNextTask(ITaskSet taskSet, IEnergyProfile energyProfile,	long date, EventGenerator evGen) {

		SortedSet<ITask> activeTasks = taskSet.getActiveTasks(date);
		if(!activeTasks.isEmpty()){
			return activeTasks.first();
		}
		return  null;
	}
	
	@Override
	public ISchedulingPolicy newInstance() {
		return new EDF(tasksetType, policyName);
	}
}
