package yartiss.engine.simulation.scheduling.policies.dp;

import yartiss.engine.simulation.ISchedulingPolicy;
import yartiss.engine.simulation.scheduling.policies.fp.EHPFP2;
import yartiss.engine.simulation.system.ITaskSet;
import yartiss.engine.simulation.system.taskset.TaskSetFactory;


/**
 * Preemptive Dynamic Priority. When there is not enough energy, the system is
 * paused until the energy level reaches a threshold 
 */
public class EHPDP2 extends EHPFP2{

	@Override
	public String getPolicyName() {
		return "EH_PDP_2";
	}
	
	@Override
	public ITaskSet createTaskSet() {
		return TaskSetFactory.getNewInstance("deadline");
	}
	
	@Override
	public ISchedulingPolicy newInstance() {
		return new EHPDP2();
	}

}
