package yartiss.engine.simulation.scheduling.policies.dp;

import yartiss.engine.simulation.ISchedulingPolicy;
import yartiss.engine.simulation.scheduling.policies.fp.PFPASAP;
import yartiss.engine.simulation.system.ITaskSet;
import yartiss.engine.simulation.system.taskset.TaskSetFactory;


/**
 * Preemptive Dynamic Priority. When there is not enough energy, the system is
 * paused for x time unit (even if it results in missing a deadline)
 */
public class PDPASAP extends PFPASAP {

	
	@Override
	public String getPolicyName() {
		return "PDP ASAP";
	}


	/**
	 * 
	 */
	@Override
	public ITaskSet createTaskSet() {
		return TaskSetFactory.getNewInstance("deadline");
	}

	
	@Override
	public ISchedulingPolicy newInstance() {
		return new PDPASAP();
	}
}
