package yartiss.engine.simulation.scheduling.policies.fp;

import java.util.SortedSet;

import yartiss.engine.simulation.IEnergyProfile;
import yartiss.engine.simulation.ISchedulingPolicy;
import yartiss.engine.simulation.events.EventGenerator;
import yartiss.engine.simulation.scheduling.policies.AbstractMonoProcessorSchedulingPolicy;
import yartiss.engine.simulation.system.ITask;
import yartiss.engine.simulation.system.ITaskSet;

public class FP extends AbstractMonoProcessorSchedulingPolicy {

	
	public FP(String tasksetType, String policyName) {
		super(tasksetType, policyName);
	}
	
	public FP(){
		super("priority", "FP");
	}
	
	@Override
	public ISchedulingPolicy newInstance() {
		return new FP(tasksetType, policyName);
	}

	@Override
	public ITask chooseNextTask(ITaskSet taskSet, IEnergyProfile energyProfile,	long date, EventGenerator evGen) {
		SortedSet<ITask> activeTasks = taskSet.getActiveTasks(date);
		
		if(!activeTasks.isEmpty()){
			return activeTasks.first();
		}
			
		return  null;
	}
}
