package yartiss.engine.simulation.statistics;

import yartiss.engine.simulation.Event;
import yartiss.engine.simulation.IStatisticCriterion;
import yartiss.engine.simulation.SimulationParameters;
import yartiss.engine.simulation.SimulationStatistics;

public abstract class AbstractStatisticCriterion implements IStatisticCriterion {

	protected SimulationParameters parameters;
	
	@Override
	public SimulationParameters getSimulationParameters() {
		return parameters;
	}

	@Override
	public void setSimulationParameters(SimulationParameters p) {
		parameters = p;
	}
	
	@Override
	public void eventPerformed(Event event) {
	}

	@Override
	public void aggregate(Object newValue, SimulationStatistics result) {
		if(result.isSuccess())
			getAggregation().aggregate(newValue);
	}
	
	protected IAggregation aggregation = new DoubleAggregation();
	public IAggregation getAggregation() {
		return aggregation;
	}
	
	@Override
	public Class<?> getValueType() {
		return Double.class;
	}
	
}
