package yartiss.engine.simulation.statistics;

import yartiss.engine.simulation.Event;
import yartiss.engine.simulation.IStatisticCriterion;

public class AverageEnergyLevelStatisticCriterion extends AbstractStatisticCriterion {

	private double avg = 0; 
	private int eventsCount = 0;
	@Override
	public void simulationStarted() {
		avg = 0;
		eventsCount = 0;
	}

	@Override
	public void simulationEnd(long date) {
		
	}

	@Override
	public void nextEventReady(Event event) {
		eventsCount++;
	}

	@Override
	public void eventPerformed(Event event) {
		super.eventPerformed(event);
		avg += event.getMetric(Event.EnergyLevel) ;
	}

	@Override
	public String getName() {
		return "Average energy level";
	}

	@Override
	public IStatisticCriterion newInstance() {
		return new AverageEnergyLevelStatisticCriterion();
	}

	@Override
	public Object getValue() {
		return avg/eventsCount;
	}

	@Override
	public Object getAggregatedValue() {
		return 	aggregation.getPercent(aggregation.getAverage(), parameters.getEnergyProfile().getMaxEnergyLevel());

	}

}
