package yartiss.engine.simulation.statistics;

import yartiss.engine.simulation.Event;
import yartiss.engine.simulation.IStatisticCriterion;

public class AverageOverheadStatisticsCriterion extends AbstractStatisticCriterion{

	private double startDate;
	private double endDate;
	private double eventsCounter = 0;
	
	@Override
	public void simulationStarted() {
		eventsCounter = 0;
		startDate = System.currentTimeMillis();
	}

	@Override
	public void simulationEnd(long date) {
		endDate = System.currentTimeMillis();
	}

	@Override
	public void nextEventReady(Event event) {
	}

	@Override
	public void eventPerformed(Event event) {
		super.eventPerformed(event);
		eventsCounter++;
	}

	@Override
	public String getName() {
		return "Average Overhead";
	}

	@Override
	public IStatisticCriterion newInstance() {
		return new AverageOverheadStatisticsCriterion();
	}

	@Override
	public Object getValue() {
		return (endDate-startDate)/eventsCounter;
	}

	@Override
	public Object getAggregatedValue() {
		return aggregation.getAverage();
	}
}
