package yartiss.engine.simulation.statistics;

public class DoubleAggregation implements IAggregation{
	private double sum=0, avg=0, max=0, min=0;
	private int count=0; 
	
	@Override
	public void aggregate(Object newValue) {
		count++;
		double d = (Double)newValue;
		sum += d;
		avg = sum/count;
		max = Math.max(max, d);
		min = Math.min(min, d);
	}

	@Override
	public Object getSum() {
		return sum;
	}

	@Override
	public Object getAverage() {
		return avg;
	}

	@Override
	public Object getMax() {
		return max;
	}

	@Override
	public Object getMin() {
		return min;
	}

	@Override
	public int getAggregationCount() {
		return count;
	}

	@Override
	public void reset() {
		sum=0;
		avg=0;
		max=0;
		min=0;
		count=0;
	}

	@Override
	public Object getPercent(Object t, Object b) {
		double B = Double.parseDouble(b.toString());
		double T = (Double)t;
		if(B<=0){B=1;T=0;}
		return T*100/B;
	}

}
