package yartiss.engine.simulation.statistics;

import yartiss.engine.simulation.Event;
import yartiss.engine.simulation.IStatisticCriterion;
import yartiss.engine.simulation.SimulationStatistics;
import yartiss.engine.simulation.events.DeadlineMissedEvent;
import yartiss.engine.simulation.events.EnergyFailureEvent;

public class FailureCountStatisticCriterion extends AbstractStatisticCriterion{

	private double failurecount = 0;
	
	@Override
	public void simulationStarted() {
		failurecount = 0;
	}

	@Override
	public void simulationEnd(long date) {
		
	}

	@Override
	public void nextEventReady(Event event) {
		
	}

	@Override
	public void eventPerformed(Event event) {
		super.eventPerformed(event);
		if(event instanceof DeadlineMissedEvent || event instanceof EnergyFailureEvent)
			failurecount ++;
	}

	@Override
	public String getName() {
		return "Failures";
	}

	@Override
	public IStatisticCriterion newInstance() {
		return new FailureCountStatisticCriterion();
	}

	@Override
	public Object getValue() {
		return failurecount;
	}
	
	@Override
	public void aggregate(Object newValue, SimulationStatistics result) {
		aggregation.aggregate(newValue);
	}
	
	@Override
	public Object getAggregatedValue() {
		return 	aggregation.getPercent(aggregation.getSum(), aggregation.getAggregationCount());
		//return aggregation.getSum();

	}

}
