package yartiss.engine.simulation.statistics;

import yartiss.engine.simulation.Event;
import yartiss.engine.simulation.IStatisticCriterion;
import yartiss.engine.simulation.events.JobExecutionEndEvent;

public class PreemptionsCountStatisticCriterion extends AbstractStatisticCriterion{

	private double counter = 0;
	
	@Override
	public void simulationStarted() {
		counter = 0;
	}

	@Override
	public void simulationEnd(long date) {
		
	}

	@Override
	public void nextEventReady(Event event) {
		
	}

	@Override
	public void eventPerformed(Event event) {
		super.eventPerformed(event);
		if(event instanceof JobExecutionEndEvent && event.getTask().getRemainingCost() > 0){
			counter ++;
		}
	}

	@Override
	public String getName() {
		return "Preemptions";
	}

	@Override
	public IStatisticCriterion newInstance() {
		return new PreemptionsCountStatisticCriterion();
	}

	@Override
	public Object getValue() {
		return counter;
	}

	@Override
	public Object getAggregatedValue() {
		return aggregation.getPercent(aggregation.getAverage(), parameters.getSimulationEnd());
	}

}
