package yartiss.engine.simulation.statistics;

import yartiss.engine.simulation.Event;
import yartiss.engine.simulation.IStatisticCriterion;
import yartiss.engine.simulation.SimulationStatistics;

public class SimulationDurationCriterion extends AbstractStatisticCriterion{

	private double end = 0;
	
	@Override
	public void simulationStarted() {
		end = 0;
	}

	@Override
	public void simulationEnd(long date) {
		end = date;
	}

	@Override
	public void nextEventReady(Event event) {

	}


	@Override
	public String getName() {
		return "Sim duration";
	}

	@Override
	public IStatisticCriterion newInstance() {
		return new SimulationDurationCriterion();
	}

	@Override
	public Object getValue() {
		return end;
	}
	
	@Override
	public void aggregate(Object newValue, SimulationStatistics result) {
		aggregation.aggregate(newValue);
	}
	
	@Override
	public Object getAggregatedValue() {
		return aggregation.getPercent(aggregation.getAverage(), parameters.getSimulationEnd());
	}

}
