/**
 * 
 */
package yartiss.engine.simulation.statistics;

import yartiss.engine.simulation.Event;
import yartiss.engine.simulation.IStatisticCriterion;
import yartiss.engine.simulation.SimulationStatistics;
import yartiss.engine.simulation.events.DeadlineMissedEvent;
import yartiss.engine.simulation.events.EnergyFailureEvent;

/**
 * @author Younes
 *
 */
public class SuccessStateStatisticsCriterion extends AbstractStatisticCriterion{

	
	
	public SuccessStateStatisticsCriterion() {
		super();
		aggregation = new BooleanAggregation();
	}

	private boolean success = true;
	@Override
	public void simulationStarted() {
		success = true;
	}

	
	@Override
	public void simulationEnd(long date) {

	}

	
	@Override
	public void nextEventReady(Event event) {

	}

	
	@Override
	public void eventPerformed(Event event) {
		super.eventPerformed(event);
		if(event instanceof DeadlineMissedEvent || event instanceof EnergyFailureEvent)
			success=false;
	}

	
	@Override
	public String getName() {
		return "Success state";
	}

	
	@Override
	public IStatisticCriterion newInstance() {
		return new SuccessStateStatisticsCriterion();
	}

	
	@Override
	public Class<?> getValueType() {
		return Boolean.class;
	}

	@Override
	public Object getValue() {
		return success;
	}
	
	@Override
	public void aggregate(Object newValue, SimulationStatistics result) {
		getAggregation().aggregate(newValue);
	}


	@Override
	public Object getAggregatedValue() {
		return aggregation.getSum();
	}


	

}
