package yartiss.engine.simulation.statistics;

import yartiss.engine.simulation.Event;
import yartiss.engine.simulation.IStatisticCriterion;

public class TimeAtEminStatisticCriterion extends AbstractStatisticCriterion {

	private double time = 0; 
	private Event lastEvent = null, currentEvent=null;
	@Override
	public void simulationStarted() {
		time = 0;
		lastEvent = null;
		currentEvent = null;
	}

	@Override
	public void simulationEnd(long date) {

	}

	@Override
	public void nextEventReady(Event event) {
		lastEvent = currentEvent==null ? event : currentEvent;
		currentEvent = event;
	}

	@Override
	public void eventPerformed(Event event) {
		super.eventPerformed(event);
		if (parameters.getEnergyProfile().getCurrentEnergyLevel() == parameters.getEnergyProfile().getMinEnergyLevel() && currentEvent.getDate() != lastEvent.getDate()) {
			time+= (currentEvent.getDate() - lastEvent.getDate());
		} 
	}

	@Override
	public String getName() {
		return "Time at Emin";
	}

	@Override
	public IStatisticCriterion newInstance() {
		return new TimeAtEminStatisticCriterion();
	}

	@Override
	public Object getValue() {
		return time;
	}

	@Override
	public Object getAggregatedValue() {
		return aggregation.getPercent(aggregation.getAverage(), parameters.getSimulationEnd());
	}

}
