package yartiss.engine.simulation.system.schedulable;

public class Job {

	private long remainingTimeCost;
	private long remainingEnergyCost;
	private final long jobId;
	private final long activationDate;
	private final long absoluteDeadline;
	/**
	 * A job should only be obtain by method Task.nextJob()
	 */
	public Job(long id, long activationDate, long wcet, long wcee, long absoluteDi) { 
		this.jobId = id;
		remainingTimeCost = wcet;
		remainingEnergyCost = wcee;
		this.activationDate = activationDate;
		absoluteDeadline = absoluteDi;
	}

	public long getJobId() {
		return jobId;
	}
	
	public long getRomainingTimeCost(){
		return remainingTimeCost;
	}
	
	public long getRomainingEnergyCost(){
		return remainingEnergyCost;
	}
	
	
	public void consumeProcTime(long duration){
		remainingTimeCost -= duration;
		assert remainingTimeCost >= 0 : "jobId ; "+jobId+" : timeCost < 0";  
	}
	
	
	public void consumeEnergy(long energy){
		remainingEnergyCost -= energy;
		assert remainingEnergyCost >= 0 : "jobId ; "+jobId+" : energyCost < 0";  
	}

	/**
	 * @return the activationDate
	 */
	public long getActivationDate() {
		return activationDate;
	}

	/**
	 * @return the absoluteDeadline
	 */
	public long getAbsoluteDeadline() {
		return absoluteDeadline;
	}
	
	
	public Job cloneJob(){
		return  new Job(jobId, activationDate, remainingTimeCost, remainingEnergyCost, absoluteDeadline );
	}
	
	
	
}
