package yartiss.engine.simulation.system.taskset;

import java.util.Comparator;

import yartiss.engine.simulation.system.ITask;
import yartiss.engine.simulation.system.ITaskSet;

public class StaticDeadlineMonotonicTaskSet  extends FixedPriorityTaskSet{
	
	public StaticDeadlineMonotonicTaskSet(){
		super(new Comparator<ITask>() {
			@Override
			public int compare(ITask t1, ITask t2) {
				long comp =  t1.getDeadline() - t2.getDeadline();
				if(comp==0)
					comp = t1.getPriority() - t2.getPriority();
				if(comp==0)
					comp =  (t1.getWcet() - t2.getWcet());
				if(comp==0)
					comp =  (t1.getWcee() - t2.getWcee());
				if(comp==0)
					comp =  (t1.getFirstRelease() - t2.getFirstRelease());
				if(comp==0)
					comp =  (t1.getPeriod() - t2.getPeriod());
				return (int) comp;
			}
		});
	}
	
	@Override
	public ITaskSet newInstance() {
		return new StaticDeadlineMonotonicTaskSet();
	}
	
	@Override
	public ITaskSet cloneTaskSet() {
		StaticDeadlineMonotonicTaskSet set = new StaticDeadlineMonotonicTaskSet();
		for (ITask task : this) {
			set.addTask(task.cloneTask());
		}
		return set;
	}
	
	@Override
	public String getName() {
		return "SDM";
	}

}
