package yartiss.engine.simulation.system.taskset;

import java.util.Comparator;

import yartiss.engine.simulation.system.ITask;
import yartiss.engine.simulation.system.ITaskSet;

public class StaticEnergyDeadlineMonotonicTaskSet  extends FixedPriorityTaskSet{
	
	private static long pr = 15;
	
	public StaticEnergyDeadlineMonotonicTaskSet(){
		super(new  Comparator<ITask>() {
			@Override
			public int compare(ITask t1, ITask t2) {
				long d1 = t1.getDeadline()*pr-t1.getWcee();
				long d2 = t2.getDeadline()*pr-t2.getWcee();
				long comp = 0;
				if(d1>=0 && d2>=0){
					comp = t1.getDeadline() - t2.getDeadline();
				}
				if(comp==0)
					comp = d2 - d1;
				
				if(comp==0)
					comp = t1.getPriority() - t2.getPriority();
				
				if(comp==0)
					comp =  t1.getPeriod() - t2.getPeriod();
				if(comp==0)
					comp =  (t1.getWcee() - t2.getWcee());
				if(comp==0)
					comp =  (t1.getFirstRelease() - t2.getFirstRelease());
				if(comp==0)
					comp =  (t1.getWcee() - t2.getWcee());
				if(comp==0)
					comp =  (t1.getDeadline() - t2.getDeadline());
				return (int) comp;
			}
		});
	}
	
	@Override
	public String getName() {
		return "SEDM";
	}
	
	@Override
	public ITaskSet newInstance() {
		return new StaticEnergyDeadlineMonotonicTaskSet();
	}
}