package yartiss.engine.test.simulation.system.taskset.generatioon;

import junit.framework.Assert;

import org.junit.Before;
import org.junit.Test;

import yartiss.engine.simulation.system.ITask;
import yartiss.engine.simulation.system.taskset.generation.task.DefaultTaskGenerator;

public class DefaultTaskGenTest {

	private DefaultTaskGenerator taskgen;

	@Before
	public void setUp(){
		taskgen = new DefaultTaskGenerator();
	}
	
	@Test
	public void generationTest(){
		
		double utilization = 0.7;
		double energyUtilization = 0.8;
		long pr = 10;
		boolean offset = false;
		int deadlineModel = 0;
		int maxProc = 1;
		ITask task = null;
		
		for (int i = 0; i < 20; i++) {
			task = taskgen.generate(utilization,energyUtilization,pr, offset, deadlineModel, maxProc );
			Assert.assertNotNull(task);
			Assert.assertTrue(utilization >= ((double)task.getWcet())/task.getPeriod());
			Assert.assertTrue(task.getDeadline() == task.getPeriod());
			Assert.assertTrue(task.getWcee() / task.getWcet() >= pr);
		}
	}
}
