package yartiss.engine.test.simulation.system.taskset.generatioon;

import java.io.InputStream;

import junit.framework.Assert;

import org.junit.Before;
import org.junit.Test;

import yartiss.engine.simulation.system.ITask;
import yartiss.engine.simulation.system.schedulable.SchedulableFactory;
import yartiss.engine.simulation.system.taskset.generation.FileTaskSetGenerator;
import yartiss.engine.simulation.system.taskset.generation.ITaskSetGenerator;


public class FileGenerationTest {
	
	
	
	private static final InputStream file = FileGenerationTest.class.getResourceAsStream("/systems/tasks_sets"); 
	private static final InputStream energyFile = FileGenerationTest.class.getResourceAsStream("/systems/energy.txt");
	private static final int pr = 10; 
	private ITaskSetGenerator generator;

	@Before
	public void setUp(){
		this.generator = new FileTaskSetGenerator(file,energyFile, pr);
	}
	
	@Test
	public void fileTaskSetGenearationTest(){
		
		generator.generate();
		generator.generate();
		generator.generate();
		generator.generate();
		generator.generate();
		ITask [] generatedSet = generator.generate();
		ITask [] expectedSet = getExpectedSet();
		int nbTasks = 6;
		Assert.assertNotNull(generatedSet);
		Assert.assertEquals(nbTasks, generatedSet.length);
		
		for (int i = 0; i < expectedSet.length; i++) {
			assertTask(expectedSet[i], generatedSet[i]);
		}
	}
	
	private void assertTask(ITask expectedTask, ITask generatedTask){
		System.out.println(expectedTask);
		System.out.println(generatedTask);
		System.out.println("-----------------------------");
//		Assert.assertEquals(expectedTask.getFirstRelease()	, generatedTask.getFirstRelease());
//		Assert.assertEquals(expectedTask.getPeriod()		, generatedTask.getPeriod());
//		Assert.assertEquals(expectedTask.getDeadline()		, generatedTask.getDeadline());
//		Assert.assertEquals(expectedTask.getPriority()		, generatedTask.getPriority());
//		Assert.assertEquals(expectedTask.getWcet()			, generatedTask.getWcet());
//		Assert.assertEquals(expectedTask.getWcee()			, generatedTask.getWcee());
	}
	
	private ITask [] getExpectedSet(){
		ITask [] set = new ITask []{
				 SchedulableFactory.newInstance("simple", 0,9,216,223,223,1),
				 SchedulableFactory.newInstance("simple", 0,4,52,245,245,2),
				 SchedulableFactory.newInstance("simple", 0,8,104,289,289,3),
				 SchedulableFactory.newInstance("simple", 0,26,286,354,354,4),
				 SchedulableFactory.newInstance("simple", 0,81,972,573,573,5),
				 SchedulableFactory.newInstance("simple", 0,4,76,1038,1038,6)
		};
		return set;
	}
}
