package yartiss.engine.test.simulation.system.taskset.generatioon;

import junit.framework.Assert;

import org.junit.Before;
import org.junit.Test;

import yartiss.engine.simulation.system.DeadlineModel;
import yartiss.engine.simulation.system.ITaskSet;
import yartiss.engine.simulation.system.SystemMetrics;
import yartiss.engine.simulation.system.schedulable.SchedulableFactory;
import yartiss.engine.simulation.system.taskset.FixedPriorityTaskSet;

public class SystemMetricsTest {
	
	private ITaskSet tasks;

	@Before
	public void setUp(){
		tasks = new FixedPriorityTaskSet();
		tasks.addTask(SchedulableFactory.newInstance("simple", 0, 1, 1, 8, 8, 1));
		tasks.addTask(SchedulableFactory.newInstance("simple", 0, 2, 2, 5, 5, 2));
		tasks.addTask(SchedulableFactory.newInstance("simple", 0, 4, 4, 10, 10, 3));
	}
	
	@Test
	public void utilisationTest(){
		double u = SystemMetrics.utilisation(tasks);
		double expectedU = 0.925;
		Assert.assertEquals(expectedU, u);
	}
	
	@Test
	public void FPbusyPeriodTest(){
		long bp = SystemMetrics.FPBusyPeriod(tasks);
		long expectedBP = 10;
		Assert.assertEquals(expectedBP, bp);
	}
	
	@Test
	public void faisibilityTest(){
		boolean ft = SystemMetrics.isFPTimeFaisible(tasks);
		boolean expected = true;
		Assert.assertEquals(expected, ft);
	}
	
	@Test
	public void DeadlineModelTest(){
		Assert.assertEquals(DeadlineModel.IMPLICITE_DEADLINE, SystemMetrics.detectDeadLineModel(tasks));
	}

}
