package yartiss.engine.test.simulation.system.taskset.generatioon;

import java.util.Arrays;

import junit.framework.Assert;

import org.junit.Before;
import org.junit.Test;

import yartiss.engine.simulation.system.ITask;
import yartiss.engine.simulation.system.SystemMetrics;
import yartiss.engine.simulation.system.taskset.generation.UUniFastDiscardTaskSetGen;
import yartiss.engine.simulation.system.taskset.generation.task.DefaultTaskGenerator;

public class UUniFastDiscardTaskSetGenTest {

	private static final int nbProc = 1;
	private static final boolean offset = false;
	private static final int deadlineModel = 0;
	private static final int nbTasks = 6;
	private UUniFastDiscardTaskSetGen generator;
	private double utilizsation = 0.8;
	private double energyUtilization = 0.8;
	private long pr = 10;
	private long Emax = 200;

	/**
	 * 
	 */
	@Before
	public void setUp() {
		this.generator = new UUniFastDiscardTaskSetGen(
				new DefaultTaskGenerator(), nbTasks, nbProc, utilizsation,
				energyUtilization, pr, Emax, deadlineModel, offset, true);
	}

	/**
	 * 
	 */
	@Test
	public void geneationTest() {

		for (int i = 0; i < 0; i++) {// TODO
			ITask[] taskset = generator.generate();
			Assert.assertNotNull(taskset);

			Assert.assertEquals(nbTasks, taskset.length);
			boolean timeFeasible = SystemMetrics.isFPTimeFaisible(taskset);
			Assert.assertTrue(timeFeasible);

			boolean energyFeasible = SystemMetrics
					.isEnergyFaisible(taskset, pr);
			double ue = SystemMetrics.energyUtilization(Arrays.asList(taskset),
					pr);
			System.out.println("Systeme " + i + " : " + timeFeasible + "   "
					+ energyFeasible + "   Ue=" + ue);

			for (ITask task : taskset) {
				assertTask(task);
				// System.out.println("\t\t"+task);
			}
			Assert.assertTrue(energyFeasible);
		}
	}

	/**
	 * 
	 * @param task
	 */
	private void assertTask(ITask task) {
		Assert.assertNotNull(task);
		Assert.assertTrue(task.getDeadline() == task.getPeriod());
		Assert.assertTrue(task.getWcee() / task.getWcet() > pr);
		Assert.assertTrue(task.getWcee() % task.getWcet() == 0);
	}
}
