package yartiss.framework.concurrency;

import java.util.concurrent.BlockingQueue;
import java.util.concurrent.Callable;

public abstract class AbstractProducer <E>{
	protected final BlockingQueue<QueueEntry<E>> queue;

	public AbstractProducer(BlockingQueue<QueueEntry<E>> queue){
		this.queue = queue;
	}

	public abstract void produce(final Callable<E> callable);

	public abstract void awaitTermination();
	public abstract void stop();
}
