package yartiss.framework.concurrency;

import java.util.concurrent.BlockingQueue;
import java.util.concurrent.Callable;

public class SequentialProducer<E> extends AbstractProducer<E> {

	public SequentialProducer(BlockingQueue<QueueEntry<E>> queue) {
		super(queue);
	}

	@Override
	public void produce(Callable<E> callable) {
		try {
			if(callable==null)
				queue.put(new QueueEntry<E>(null));
			
			E result = callable.call();

			if(result != null)	
				queue.put(new QueueEntry<E>(result));
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@Override
	public void awaitTermination() {

	}

	@Override
	public void stop() {

	}

}
