/*
 * Copyright (c) 2012, LIGM and University of Paris-Est. All rights reserved.
 * 
 * 
 * This file is part of YARTISS.
 * 
 * YARTISS is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * YARTISS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with YARTISS.  If not, see <http://www.gnu.org/licenses/>.
 */

package yartiss.gui.main;

import java.awt.Container;

import javax.swing.JApplet;
import javax.swing.UIManager;

@SuppressWarnings("serial")
public class AppletMain extends JApplet{

	@Override
	public void init() {
		try {
			UIManager.setLookAndFeel(
					UIManager.getCrossPlatformLookAndFeelClassName());
		} catch (Exception e) {
			e.printStackTrace();
		}
		final DesktopMain main = new DesktopMain(){
			@Override
			public void setContentPane(Container c){
				super.setContentPane(c);
				AppletMain.this.setContentPane(c);
				AppletMain.this.revalidate();
			}
		};
		setContentPane(main.getContentPane());
		setJMenuBar(main.getJMenuBar());
	}
}
